// DemoDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg Dialogfeld

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	m_vstVal = _T("Channel");
	m_vStID = _T("ID:");
	m_vStPortState = _T("Port closed");
	m_vStSN = _T("SN:");
	m_bEcho = TRUE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_Baud, m_cCbBaud);
	DDX_Control(pDX, IDC_PortNr, m_cCbPortNr);
	DDX_Control(pDX, IDC_Ch, m_cCbCh);
	DDX_Control(pDX, IDC_Read, m_cBnRead);
	DDX_Control(pDX, IDC_Init, m_cBnInit);
	DDX_Text(pDX, IDC_ST_VAL, m_vstVal);
	DDX_Text(pDX, IDC_ID, m_vStID);
	DDX_Text(pDX, IDC_PortState, m_vStPortState);
	DDX_Text(pDX, IDC_SN, m_vStSN);
	DDX_Check(pDX, IDC_Echo, m_bEcho);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Close, OnBtnClose)
	ON_BN_CLICKED(IDC_OpenPort, OnOpenPort)
	ON_BN_CLICKED(IDC_Init, OnInit)
	ON_BN_CLICKED(IDC_Read, OnRead)
	ON_BN_CLICKED(IDC_Echo, OnEcho)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg Standard functions



BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen

	// initialise the dialog-components
	m_cCbPortNr.SetCurSel(0);
	m_cCbCh.SetCurSel(1);
	m_cCbBaud.SetCurSel(0);

	// define the adress of the connected device (250 = default)
	m_cCtrl.m_nDevice= 250;
	m_cCtrl.InitCommunication();

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CDemoDlg::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Speziellen Code hier einfgen und/oder Basisklasse aufrufen

	return CDialog::Create(IDD, pParentWnd);
}

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg user-functions

void CDemoDlg::OnBtnClose() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	// Close the port
	m_cCtrl.CloseCommPort();
	// Close the application
	OnCancel();	
}

void CDemoDlg::OnOpenPort() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	CString S;	
	_u32 baud;

	// Get the portnumber
	GetDlgItemText(IDC_PortNr, S);
	
	LPTSTR lpsz = new TCHAR[S.GetLength()+1];
	_tcscpy(lpsz, S);

	switch(m_cCbBaud.GetCurSel()) {
		case 0: baud= 9600;
				break;
		case 1: baud= 115200;
	}

	//  Open the port
	m_cCtrl.OpenCommPort(lpsz, baud);
	
	m_vStPortState= "Port open";
	UpdateData(FALSE);

	// Enable the function-buttons
	m_cBnInit.EnableWindow(TRUE);
	m_cBnRead.EnableWindow(TRUE);
}

void CDemoDlg::OnInit() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	_u8 nClass;
	_u8 nGroup;
	_u8 nYear; 
	_u8 nWeek;
	_u8 nBuffer;
	_u8 nState;
	_u32 nSN;
	CString S;

	// First F48 call should wake-up the device
	m_cCtrl.F48(&nClass, &nGroup, &nYear, &nWeek, &nBuffer, &nState);
	Sleep(200);

	// Initialise the device
	nRes= m_cCtrl.F48(&nClass, &nGroup, &nYear, &nWeek, &nBuffer, &nState);
	// Check the answer
	if(nRes!= COMM_OK) 
	{
		S= "Initialisation not possible !";
		AfxMessageBox((LPCTSTR)S,MB_OK|MB_ICONSTOP);
		return;
	}
	// Show the answer
	m_vStID.Format(_T("ID: %d.%d  Version: %d.%d"), nClass, nGroup, nYear, nWeek);
	UpdateData(FALSE);

	// Read the Serialnumber
	nRes= m_cCtrl.F69(&nSN);
	// Check the answer
	if(nRes!= COMM_OK) 
	{
		S= "Reading of SN not possible !";
		AfxMessageBox((LPCTSTR)S,MB_OK|MB_ICONSTOP);
		return;
	}
	// Show the answer
	m_vStSN.Format(_T("SN: %d"), nSN);	
	UpdateData(FALSE);
}

void CDemoDlg::OnRead() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	float fVal;
	_u8 bCh;
	CString S;

	// Get channel to read
	bCh= m_cCbCh.GetCurSel();

	// Read the actual value
	nRes= m_cCtrl.F73(bCh,&fVal);
	// Check the answer
	if(nRes!= COMM_OK) 
	{
		S= "Reading of value not possible !";
		AfxMessageBox((LPCTSTR)S,MB_OK|MB_ICONSTOP);
		return;
	}

	// Convert the answer to a string
	S.Format(_T("%6.5f"), fVal);

	// Show the answer with specially formated font

	TCHAR   szt[50];
	LOGFONT	m_Font;
	CFont font;
	LPCTSTR lpsz(S);

	// CEdit lschen
	((CEdit*)GetDlgItem(IDC_VAL))->SetSel(0, -1);
	((CEdit*)GetDlgItem(IDC_VAL))->ReplaceSel(_T(""));

    m_Font.lfHeight = 440; 

    m_Font.lfWidth = 0; 
    m_Font.lfEscapement = 0; 
    m_Font.lfOrientation = 0; 
	m_Font.lfWeight = 600; 
	m_Font.lfItalic = 0; 
	m_Font.lfUnderline = 0; 
	m_Font.lfStrikeOut = 0; 
	m_Font.lfCharSet = 0; 
	m_Font.lfOutPrecision = 0; 
	m_Font.lfClipPrecision = 0; 
	m_Font.lfQuality = 0; 
	m_Font.lfPitchAndFamily = 0; 

	CDC* pDC= ((CEdit*)GetDlgItem(IDC_VAL))->GetDC();

	// erzeuge das Font Objekt
	if (font.CreatePointFontIndirect(&m_Font, NULL)) //CreateFontIndirect(&m_Font))
	{
		// Font in den DC selektieren
		CFont* pOldFont = pDC->SelectObject(&font);
		((CEdit*)GetDlgItem(IDC_VAL))->SetFont(&font, FALSE);
	}

	_stprintf(szt, _T("%s"), lpsz);
	((CEdit*)GetDlgItem(IDC_VAL))->SetSel(65534, 65534, TRUE);
	((CEdit*)GetDlgItem(IDC_VAL))->ReplaceSel(szt);	

	UpdateData(FALSE);	

}

void CDemoDlg::OnEcho() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	// Set echo
	UpdateData(TRUE);
	m_cCtrl._bEcho= m_bEcho;	
}
