//
//
//	---------------------------------------------------------
//	Beispielprogramm zum Einbinden der S30c.dll der Keller AG
//	---------------------------------------------------------
//
//	Die dll enthlt die Funktionen zur Kommunikation mit Serie 30 Transmittern
//	oder zum Manometer "Leo".
//	Die dll muss sich im gleichen Pfad ,wie das .exe befinden.
//
//
//	Keller AG Winterthur
//	St.Gallerstr. 119
//	8404 Winterthur
//
//
//	07.12.00 M.Gautschi
//
//	---------------------------------------------------------
//
#include "stdafx.h"
#include "DLL_Einbinden.h"
#include "DLL_EinbindenDlg.h"
//
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//
//
/////////////////////////////////////////////////////////////////////////////
// Deklaration bzw Einbinden der DLL
//
HINSTANCE gS30iDLL = NULL;

typedef _int16 (__stdcall *S30OPENCOMPORT) (_int16 ,_int16 );
S30OPENCOMPORT S30_OpenComPort;
//
typedef _int16 (__stdcall *S30CLOSECOMPORT) (void);
S30CLOSECOMPORT S30_CloseComPort;
//
typedef _int16 (__stdcall *S30FUNCTION48) (BYTE ,BYTE*,BYTE*,BYTE*,BYTE*,BYTE*,BYTE* );
S30FUNCTION48 S30_F48;
//
typedef _int16 (__stdcall *S30FUNCTION73) (BYTE ,BYTE,float*,BYTE* );
S30FUNCTION73 S30_F73;
//
/////////////////////////////////////////////////////////////////////////////
//
// Globale Variablen
//
short int Port,Timeout,Returnval;
unsigned char S30class, S30Group, S30Year, S30Week, S30Buffer, S30State;
float S30Pressureval;
CString Ausgabetext;
//
/////////////////////////////////////////////////////////////////////////////
//
//
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDLL_EinbindenDlg dialog

CDLL_EinbindenDlg::CDLL_EinbindenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDLL_EinbindenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDLL_EinbindenDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDLL_EinbindenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDLL_EinbindenDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}
//
BEGIN_MESSAGE_MAP(CDLL_EinbindenDlg, CDialog)
	//{{AFX_MSG_MAP(CDLL_EinbindenDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LoadS30i, OnLoadS30i)
	ON_BN_CLICKED(IDC_OpenComPort, OpenComPort)
	ON_BN_CLICKED(IDC_F48, OnF48)
	ON_BN_CLICKED(IDC_F73, OnF73)
	ON_BN_CLICKED(IDC_Beenden, OnBeenden)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDLL_EinbindenDlg message handlers

BOOL CDLL_EinbindenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDLL_EinbindenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDLL_EinbindenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDLL_EinbindenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//
void CDLL_EinbindenDlg::OnLoadS30i() 
{
  // TODO: Add your control notification handler code here
  gS30iDLL = LoadLibrary("S30c.dll");  //oder Pfad, in der sich die dll befindet !
  //
  if(gS30iDLL==NULL)
  {	MessageBox("Konnte S30c.dll nicht laden !");
	return;
  }
  //
  S30_OpenComPort=(S30OPENCOMPORT)GetProcAddress(gS30iDLL,"OpenComPort");
  if (gS30iDLL==NULL)
  {
	MessageBox("S30c.dll enthlt 'OpenComPort' nicht!");
	return;
  }
  S30_CloseComPort=(S30CLOSECOMPORT)GetProcAddress(gS30iDLL,"CloseComPort");
  if (gS30iDLL==NULL)
  {
	MessageBox("S30c.dll enthlt 'OpenComPort' nicht!");
	return;
  }
  S30_F48=(S30FUNCTION48)GetProcAddress(gS30iDLL,"F48");
  if (gS30iDLL==NULL)
  {
	MessageBox("S30c.dll enthlt 'F48' nicht!");
	return;
  }
  S30_F73=(S30FUNCTION73)GetProcAddress(gS30iDLL,"F73");
  if (gS30iDLL==NULL)
  {
	MessageBox("S30c.dll enthlt 'F73' nicht!");
	return;
  }

  GetDlgItem(IDC_OpenComPort)->EnableWindow(TRUE);
  GetDlgItem(IDC_LoadS30i)->EnableWindow(FALSE);
}
//
void CDLL_EinbindenDlg::OpenComPort() 
{
	// TODO: Add your control notification handler code here
	Port=1;
	Timeout=500;
	Returnval=S30_OpenComPort(1,500);	
	if (Returnval)
	{
		return;
	}
	else
	{
		GetDlgItem(IDC_F48)->EnableWindow(TRUE);
		GetDlgItem(IDC_OpenComPort)->EnableWindow(FALSE);
	}
}
//
void CDLL_EinbindenDlg::OnF48() 
{
	// TODO: Add your control notification handler code here
	Returnval = S30_F48( 250, &S30class, &S30Group, &S30Year, &S30Week, &S30Buffer, &S30State );
	if (Returnval)
	{
		GetDlgItem(IDC_LoadS30i)->EnableWindow(TRUE);
		GetDlgItem(IDC_OpenComPort)->EnableWindow(FALSE);
		GetDlgItem(IDC_F48)->EnableWindow(FALSE);
		return;
	}
	else
	{
		
		GetDlgItem(IDC_OpenComPort)->EnableWindow(FALSE);
		GetDlgItem(IDC_F73)->EnableWindow(TRUE);
		Ausgabetext.Format("Class %d   Group %d   Year %d   Week %d   Buffer %d   Status %d ",S30class,S30Group,S30Year,S30Week,S30Buffer,S30State);
		MessageBox(Ausgabetext);
	}	
}
//
void CDLL_EinbindenDlg::OnF73() 
{
	// TODO: Add your control notification handler code here
	Returnval = S30_F73( 250, 1, &S30Pressureval, &S30State );
	if (Returnval)
	{
		GetDlgItem(IDC_LoadS30i)->EnableWindow(TRUE);
		GetDlgItem(IDC_OpenComPort)->EnableWindow(FALSE);
		GetDlgItem(IDC_F48)->EnableWindow(FALSE);
		return;
	}
	else
	{
		Ausgabetext.Format("Druck = %.3f     Status %d ",S30Pressureval,S30State);
		MessageBox(Ausgabetext);
	}	
	
}
//
void CDLL_EinbindenDlg::OnBeenden() 
{
	// TODO: Add your control notification handler code here

	Returnval=S30_CloseComPort();	
	FreeLibrary(gS30iDLL);
	gS30iDLL = NULL;
 	DestroyWindow();
}
